#!/bin/bash
# does not work with /bin/sh

VARPATH=/var/run/
TMPPATH=/tmp/

BROKER=broker.pid
FRONTAL=frontale.pid
CONNHELPER=connection_helper.pid
PROXY=proxy.pid

MACHINEFILE=/tmp/machinefile

help_exit() {
    [ -n "$1" ] && echo "\`$1': option not allowed" >&2
    echo "Usage: $0 [OPTIONS]" >&2
    echo "  where options are:" >&2
    echo "  -c|--conf           /path/to/configfile  defaults to \`$CONFIG'" >&2
    echo "  -h|--help           displays this help and exits" >&2
    exit 1
}

TEMP=$(getopt -o c:h --long conf:,help -n "qcgrte-clean" -- "$@")
while true; do
    case "$1" in
	-c|--conf)
	    CONFIG=$2
	    shift 2
	    ;;
	-h|--help)
	    help_exit ""
	    ;;	
	*)
	    [ -z "$1" ] && break
	    help_exit $1
	    ;;
    esac
done

if [ ! -f $CONFIG ]; then
    echo "config file not found" >&2
    help_exit ""
fi



if [ -e $VARPATH$BROKER ] ; then
    echo $VARPATH$BROKER" exists"
    USEPATH=$VARPATH
else
    echo $VARPATH$BROKER" does not exist, try "$TMPPATH$BROKER
    if [ -e $TMPPATH$BROKER ] ; then
	echo $TMPPATH$BROKER" exists."
	USEPATH=$TMPPATH
    else
	echo "cannot find pid files. Exit."
	exit 1
    fi
fi

# kill the broker
kill -TERM \`cat $USEPATH$BROKER\`
rm $USEPATH$BROKER

# kill the proxy
kill -TERM \`cat $USEPATH$PROXY\`
rm $USEPATH$PROXY

# kill the frontals
FRONTMACHINES=$(awk ' $1 ~ /^[0-9]+$/ {print $4}' $CONFIG)
for f in $FRONTMACHINES; do    
    ssh $f kill -TERM \`cat $USEPATH$FRONTAL\`
    ssh $f rm $USEPATH$FRONTAL
done

# kill the connection helpers
for f in $(cat $MACHINEFILE) ; do 
    ssh $f kill -TERM \`cat $USEPATH$CONNHELPER\`
    ssh $f rm $USEPATH$CONNHELPER
done
